<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head>


  <meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">
  <title>Cidero - Home</title>
  <link rel="stylesheet" type="text/css" href="radioServer-Dateien/test.css">
</head><body>

<!-- Under construction image at top left -->
<div id="construction" title="construction">
<!--<img src="undercon.gif"/>-->
</div>

<!-- Banner image at top left -->
<div id="banner"><img src="radioServer-Dateien/cideroWebBanner.gif" alt="Banner" align="left">
</div>

<!-- Separator -->
<div id="sep">
<hr style="width: 1000px; height: 4px;">
</div>

<!-- Navigation bar on left -->
<div id="pageNav">
<a href="http://www.cidero.com/index.html">Home</a>
<a href="http://www.cidero.com/downloads.html">Downloads</a>
<a href="http://www.cidero.com/forums/index.php">Forums</a>
<a href="http://www.cidero.com/links.html">Links</a>
</div>
<!-- <a href="contacts.html">Contacts</a> -->

<!-- Page content on right -->
<div id="pageContent">

<h2>UPnP Internet Radio Station Server</h2>

<a href="#intro">Introduction</a><br>
<a href="#db">Radio Station Database</a><br>
<a href="#browsetree">Server Browse Tree</a><br>
<a href="#proxy">Proxy Mode</a><br>
<a href="#sync">Multi-Renderer Synchronization</a><br>
<a href="#webpage">Web Page Presentation</a><br>
<a href="#pref">Command-Line Arguments and User Preference Files</a><br>


<h3><a name="intro">Introduction</a></h3> This UPnP media server
application parses a directory tree of ASCII-based XML radio station
metadata files and exports the radio station data to interested UPnP
control points. A default radio station database of 60-plus popular
(shoutcast-only at the moment) internet radio stations is supplied with
the server. Users may stations by simply creating new station files,
using existing files as a template. The exported server browse tree
reflects the structure of the station database directory tree, allowing
users to modify the server's browse tree if desired by simply adding to
or modifying the database directory tree on disk.<br>
<br>


<h3><a name="db">Radio Station Database</a></h3>
The radio station database consists of a set of XML files, one per
station, in a simple directory heirarchy. The default database is
located in the <i>$INSTALL_DIR/db/radiodb</i>.
By convention, one directory is named 'AllStations' and contains the
master list of all the stations in the database. When adding stations
to the database, one should always add it to the 'AllStations'
directory. User's wishing to break the stations up into categories of
their choosing may do so by creating category directories and
subdirectories to any nesting depth, and filling the directories with
copies of (or, if the OS supports it, symbolic links to) the XML files
in the AllStations directory. The UPnP browse heirarchy exported by the
server will reflect the directory structure on disk. For convenience, a
'Genres' category is automatically generated by the server when it is
started up, using the genre metadata in the database.<br>
<br> A sample database file for www.radioparadise.com is shown below.
As previously mentioned, the UPnP DIDL-Lite XML format is used since
the UPnP packages implicitly provide support for it, and it nicely
contains all the relevant metadata for a single radio station.<br>
<br>

<code>&lt;?xml version="1.0" encoding="UTF-8" ?&gt;<br>
&lt;DIDL-Lite xmlns="urn:schemas-upnp-org:metadata-1-0/DIDL-Lite"
xmlns:dc="http://purl.org/dc/elements/1.1/"
xmlns:upnp="urn:schemas-upnp-org:metadata-1-0/upnp"&gt;<br>
&lt;item&gt;<br>
&nbsp;
&lt;upnp:class&gt;object.item.audioItem.audioBroadcast&lt;/upnp:class&gt;<br>
&nbsp; &lt;dc:creator&gt;Bill &amp;amp; Rebecca&lt;/dc:creator&gt;<br>
&nbsp; &lt;dc:title&gt;Radio Paradise&lt;/dc:title&gt;<br>
&nbsp; &lt;upnp:genre&gt;Rock&lt;/upnp:genre&gt;<br>
&nbsp; &lt;dc:description&gt;Eclectic Mix of Adult Rock&lt;/dc:description&gt;<br>
&nbsp; &lt;upnp:region&gt;US - Northern California&lt;/upnp:region&gt;<br>
&nbsp; &lt;dc:language&gt;English&lt;/dc:language&gt;<br>
&nbsp; &lt;dc:relation&gt;http://www.radioparadise.com&lt;/dc:relation&gt;<br>
&nbsp; &lt;upnp:radioCallSign&gt;&lt;/upnp:radioCallSign&gt;<br>
&nbsp; &lt;upnp:radioStationID&gt;&lt;/upnp:radioStationID&gt;<br>
&nbsp; &lt;upnp:radioBand&gt;Internet&lt;/upnp:radioBand&gt;<br>
&nbsp; &lt;res protocolInfo="http-get:*:audio/mpegurl:*"
bitrate="16384"&gt;http://www.radioparadise.com/musiclinks/rp_128.m3u&lt;/res&gt;<br>
&nbsp; &lt;res protocolInfo="http-get:*:audio/mpegurl:*"
bitrate="8192"&gt;http://www.radioparadise.com/musiclinks/rp_64.m3u&lt;/res&gt;<br>
&nbsp; &lt;res protocolInfo="http-get:*:audio/mpegurl:*"
bitrate="4096"&gt;http://www.radioparadise.com/musiclinks/rp_32.m3u&lt;/res&gt;<br>
&lt;/item&gt;<br>
&lt;/DIDL-Lite&gt;<br>
<br>
</code>

<h4>Database Field Notes</h4>
Radio stations commonly transmit multiple types of content. The
convention used for the station database is to allow multiple genres to
be specified in the genre field, separated by commas. The convention
used for sub-genres (e.g. 'Rock/Metal') is to use a '/' to separate the
genre/sub-genre. Lastly, for stations that do support multiple genres,
the primary genre is always specified first in the comma-separated
list. This is done so that for MediaRenderer clients that may be
confused by multiple genres, the server can trim back the genre field
to only the primary field when responding to UPnP browse requests.<br>
<br>
The current list of genres in the default database is:
Ambient, Alternative, Classical, College, Country, Dance, Folk, House,
Indie, Jazz, Latin, New Age, News, Public Radio, Rock, Rock/Pop,
Rock/Metal, Techno, Top Hits, Top Hits/80's, and Trance. Note that we
make no claims regarding the proper choice of genre(s) for each station
- users should feel free to adjust them as appropriate!<br>
<br> One piece of information that is sometimes of interest when
listening to Internet radio is the station's primary geographical
location. This is specified using the 'upnp:region' field. The UPnP
specification leaves the exact format of the content of this field
unspecified. The convention used here is to specify the country first,
followed by a '-', followed by the 'region' within that country. For
well known cities (New York, London), the city name is sufficient. For
smaller cities, a more general term is specified (e.g. 'Northern
California'). This convention is not cast in stone, and deviations from
it certainly won't break anything.<br>
<br>
Stations that actually transmit on the airwaves will have non-blank
radio call sign and radioStationID (frequency) elements, and the
radioBand element will be set to the band of the transmission (AM,FM,
etc...) instead of 'Internet' (which in the context of the database
really means 'Internet-Only')<br>
<br>
The current default <a href="http://www.cidero.com/stationdb.html">station database</a>
consists of approximately 60 stations. All of the URLs currently stored
in the database refer to MP3 streams. Additional URLs for other formats
can be added to existing stations if desired, since each station file
supports an arbitrary number of resources for streaming audio access.
There is no nice UI for modifying the database yet, so for the
time-being changes to station files must be accomplished via
hand-editing.<br>
<br>

<h3><a name="browsetree">Server Browse Tree</a><a></a></h3>

<a>The server generates a multi-level browse tree from the station database. For each station in the <i>AllStations</i> directory, the following tree of nodes is generated.<br>
<br>
A screenshot of the default browse tree presented by the radio server
is shown below. Note that the browse tree nodes at the individual
station level and above simply reflect the heirarchy of the radio
station database directory tree stored on disk. The user can easily
customize the station heirarchy by simply modifying the disk directory
structure<br>
<br>
<img src="radioServer-Dateien/RadioServerBrowseTree.gif" alt="Media Controller" hspace="10" vspace="10"><br>
<br>

</a><h3><a name="proxy">Proxy Mode</a><a></a></h3>

<a>Ths server supports a proxy mode that can function as a 'repeater'
to enable a single connection to an Internet radio station to serve
multiple devices inside the home. The proxy mode simply converts radio
station URLs of the form:<br>
<br>
&nbsp;http://<i>stationHost:stationPort</i>/station.pls<br>
<br>
to the form:
&nbsp;http://<i>proxyHost:proxyPort</i>/<i>stationHost:stationPort</i>/station.pls<br>
<br>
before sending them to the requesting device. Media renderers then
request their content from the HTTP proxy server running within the
radio server rather than from the external Web address of a radio
station.
</a><h3><a name="sync">Multi-Renderer Synchronization</a><a></a></h3>

<a>When the server is operation in proxy mode, it has the opportunity
to try to ouput data in a synchronized fashion to multiple devices. In
the absence of an accurate network-wide time reference and sync-aware
media renderer devices, this is limited to simply feeding data to the
multiple devices of the same type as synchronously as possible. The
assumption that makes this possible is that the output streams to
devices of the same type have the same end-to-end buffering capacity.
As long as the streaming source takes care to balance the streams so
the buffers are 'equally full' for all devices in a synchronized group,
some degree of synchronization can typically be achieved.<br>
<br>
This feature is still only partially implemented, and synchronization
logic is only being executed at the start of a playback session. The
only way to use this sync logic at the moment is to start the multiple
renderers within the sync period of the server (default of 4 seconds,
but can be increased). This is best accomplished via the media
controller, not the remote controls of the devices themselves
(otherwise a different form of 'shoutcast' between 2 people may be
required to start devices in different rooms!). Using this method,
synchronization is generally achieved at the start, inter-device timing
drift can result in a gradual loss of sync over time (1-2 hours). The
only way to currently deal with this is to restart the stream to
re-sync it.<br>
<br>
This feature obviously isn't quite ready from the perspective of
user-friendly interaction - it's described here for purposes of
experimentation only at this point! <br>
<br> 

</a><h3><a name="sync">Web Page Presentation</a><a></a></h3>

<a>The UPnP device specification supports an optional (but recommended)
'presentation' URL which is typically used to allow Web-based access to
status and/or configuration data for a given device. The radio server
supports this by providing a simple status page containing the run-time
settings and a dynamically generated Web page with a list of all the
current stations. The simplest way to access the page is via the </a><a href="http://www.cidero.com/mediaController.html#devinfo">Media Controller's Options-&gt;DeviceInfo menu</a>. No run-time configuration of the device is supported at this time via the Web interface.

<h3><a name="pref">Command-Line Arguments and User Preference Files</a></h3>
The radio server supports user preferences via Java property files,
which use a simple text-based format. These property files are
currently only hand-editable (no Web interface), but the need to
actually edit the file is reduced by the support of the most commonly
changed options via command-line arguments.
<h4>Supported command-line options</h4>

Usage: java RadioServer [-v] [-p] [-s syncWaitPeriod] [-w webPageDir]<br>
<br>
<div style="margin-left: 40px;">[-v]&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
Verbose
mode&lt;br&gt;<br>
[-p]&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
Enable
proxy mode&lt;br&gt;<br>
[-s syncWaitPeriod]&nbsp; Period to wait for other devices to join a
synchronous<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
playback
session, in milliseconds (only applicable in proxy mode)<br>
[-w webPageDir]&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; At startup, write out the
station database in HTML<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
format
to the specified directory&lt;br&gt;<br>
</div>
<br>


<h4>Hand-editing the user-specific preference file</h4>
If modifying the preferences by hand, it is useful to understand a
little bit about how the preferences mechanism is set up, especially
with regard to how things are handled with regard to software updates.
There are two copies of the preferences file used by the controller,
one containing the 'factory default' settings
($INSTALL_DIR/properties/RadioServer.properties) and one containing the
user-specific settings
($USER_HOME/.cidero/RadioServer/RadioServer.properties). At startup,
the default settings are loaded first, followed by the user settings.
The user-specific preferences override the defaults. If the user
preferences file does not exist (first time application is run), it is
created by making a copy of the default file. When the radio server
software is updated, some preferences may have been added or removed.
Addition of the new preferences, and removal of preferences that are no
longer supported, is handled automatically at server startup. Note that
if hand-editing the file corrupts the file somehow, the simplest fix is
to remove the file and re-run the application to create a new one.<br>
<br>


</div>

</body></html>